package org.nakedobjects.nos.store.hibernate;

import org.nakedobjects.nof.reflect.java.AbstractJavaObjectLoaderInstaller;
import org.nakedobjects.nof.reflect.java.JavaDomainObjectContainer;
import org.nakedobjects.nof.reflect.java.JavaObjectLoader;


public class HibernateObjectLoaderInstaller extends AbstractJavaObjectLoaderInstaller {

    public String getName() {
        return "hibernate";
    }

    /**
     * Replaces default implementation with a Hibernate-specific implementation,
     * {@link HibernateObjectLoaderImpl}.
     */
    protected JavaObjectLoader createObjectLoader() {
        return new HibernateObjectLoaderImpl();
    }

    /**
     * Replaces default implementation with a Hibernate-specific implementation, {@link HibernateContainer}.
     */
    protected JavaDomainObjectContainer createDomainObjectContainer() {
        return new HibernateContainer();
    }
}
// Copyright (c) Naked Objects Group Ltd.
