package org.nakedobjects.nos.store.hibernate;

import org.nakedobjects.noa.adapter.Oid;
import org.nakedobjects.nof.core.persist.OidGenerator;
import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.core.util.ToString;

import org.apache.log4j.Logger;

public class HibernateOidGenerator implements OidGenerator {
	private static final Logger LOG = Logger.getLogger(HibernateOidGenerator.class);
    private static  long transientId = 0;
    
	public void convertPersistentToTransientOid(final Oid oid) {}

	public void convertTransientToPersistentOid(final Oid oid) {
		((HibernateOid)oid).makePersistent();
        LOG.debug("converted transient OID to persistent " + oid);
	}

	public synchronized Oid createTransientOid(final Object object) {
        HibernateOid oid = new HibernateOid(object.getClass(), transientId++);
        LOG.debug("created OID " + oid + " for " + new ToString(object));
        return oid;
	}

	public String name() {
		return "Hibernate Oids";
	}

	public void init() {}

	public void shutdown() {}

	public void debugData(final DebugString debug) {}

	public String debugTitle() {
		return null;
	}
}
// Copyright (c) Naked Objects Group Ltd.
