package org.nakedobjects.nos.store.hibernate.nof2hbm;

import org.nakedobjects.noa.reflect.NakedObjectField;

/**
 * Association from one class to another (one to one, many to one, many to many) which
 * is mapped as "inverse".
 */
public class Association {
	private final PersistentNakedClass persistentClass;
	private final NakedObjectField field;
	private final boolean inverse;
	
	public Association(final PersistentNakedClass persistentClass, final NakedObjectField field, final boolean inverse) {
		this.persistentClass = persistentClass;
		this.field = field;
		this.inverse = inverse;
	}

	public NakedObjectField getField() {
		return field;
	}

	public boolean isInverse() {
		return inverse;
	}

	public PersistentNakedClass getPersistentClass() {
		return persistentClass;
	}
}
// Copyright (c) Naked Objects Group Ltd.
