package org.nakedobjects.nos.store.hibernate.nof2hbm;

import java.util.StringTokenizer;

import org.nakedobjects.noa.NakedObjectRuntimeException;
import org.nakedobjects.noa.reflect.NakedObjectReflector;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nof.core.util.NakedObjectConfiguration;
import org.nakedobjects.nof.reflect.spec.NoMemberSpecification;
import org.nakedobjects.nos.store.hibernate.HibernateUtil;

public class MappingHelper {
	private static final String LIST_SEPARATOR = ", ";
    private static final String NAKEDOBJECTS_CLASSES_LIST = HibernateUtil.PROPERTY_PREFIX+"classes";
	private static final String NAKEDOBJECTS_CLASSES_PREFIX = HibernateUtil.PROPERTY_PREFIX + "classes.prefix";
	

	public static void loadRequiredClasses() {
		NakedObjectConfiguration configuration = NakedObjectsContext.getConfiguration();
		NakedObjectReflector loader = NakedObjectsContext.getReflector();
	    String classPrefix = configuration.getString(NAKEDOBJECTS_CLASSES_PREFIX);
	    classPrefix = classPrefix == null ? "" : classPrefix.trim();
	    if(classPrefix.length() > 0 && !classPrefix.endsWith(".")) {
	        classPrefix = classPrefix + ".";
	    }
	    String classList = configuration.getString(NAKEDOBJECTS_CLASSES_LIST);
	    if (classList != null) {
	        StringTokenizer classes = new StringTokenizer(classList, LIST_SEPARATOR);
	        while (classes.hasMoreTokens()) {
	            NakedObjectSpecification specification = loader.loadSpecification(classPrefix + classes.nextToken().trim());
                if (specification instanceof NoMemberSpecification) {
                    throw new NakedObjectRuntimeException("No such class " + specification.getFullName());
                }
	        }
	    }
	}
}
// Copyright (c) Naked Objects Group Ltd.
