package org.nakedobjects.nos.store.hibernate.property;

import java.util.Date;

import org.nakedobjects.nos.store.hibernate.LongVersion;

/**
 * Accesses NakedObjects update timestamp, possibly for use in optimistic locking.
 */
public class TimestampAccessor extends OptimisticLockAccessor {
	public static LongVersionAccessor TIMESTAMP_ACCESSOR = new LongVersionAccessor() {
		public Object get(final LongVersion version) {
		    return version.getTime();
		}

		public Class getReturnType() { return Date.class;	}

		public void set(final LongVersion version, final Object value) {
	    	version.setTime((Date) value);
		}
	};
	
	protected LongVersionAccessor getLongVersionAccessor() {
		return TIMESTAMP_ACCESSOR;
	}
}
// Copyright (c) Naked Objects Group Ltd.
