package org.nakedobjects.nos.store.hibernate.property;

import org.nakedobjects.nos.store.hibernate.LongVersion;

/**
 * Accesses NakedObjects user.
 */
public class UserAccessor extends OptimisticLockAccessor {
	public static LongVersionAccessor USER_ACCESSOR = new LongVersionAccessor() {
		public Object get(final LongVersion version) {
			return version.getUser();
		}

		public Class getReturnType() { return String.class; }

		public void set(final LongVersion version, final Object value) {
			version.setUser((String) value);
		}
	};

	protected LongVersionAccessor getLongVersionAccessor() {
		return USER_ACCESSOR;
	}

}
// Copyright (c) Naked Objects Group Ltd.
