package org.nakedobjects.nos.store.hibernate.security;

import org.nakedobjects.nof.reflect.peer.ReflectionPeerFactory;
import org.nakedobjects.nof.reflect.peer.ReflectionPeerFactoryInstaller;
import org.nakedobjects.nof.reflect.security.AuthorisationManager;
import org.nakedobjects.nof.reflect.security.SecurityPeerFactory;


public class DatabaseSecurityPeerFactoryInstaller implements ReflectionPeerFactoryInstaller {
    
    public ReflectionPeerFactory[] createFactories() {
        SecurityPeerFactory factory = new SecurityPeerFactory();
        AuthorisationManager authManager = new DatabaseAuthorisationManager();
        factory.setAuthorisationManager(authManager);
        return new ReflectionPeerFactory[] {factory};
    }

    public String getName() {
        return "database-security";
    }
}
