package org.nakedobjects.nos.store.hibernate.service;

import org.nakedobjects.nof.reflect.remote.data.Data;
import org.nakedobjects.nos.remote.command.java.AbstractCriteriaData;


public class HibernateQueryData extends AbstractCriteriaData {

    private static final long serialVersionUID = 1L;
    private final int resultType;
    private final Data[] objectData;
    private final byte[] queryAsBytes;

    public HibernateQueryData(final HibernateQueryCriteria criteria, final byte[] queryAsBytes, final Data[] data) {
        super(criteria);
        this.objectData = data;
        this.queryAsBytes = queryAsBytes;
        resultType = criteria.getResultType();
    }

    public Data[] getData() {
        return objectData;
    }

    public Class getCriteriaClass() {
        return HibernateQueryCriteria.class;
    }

    public int getResultType() {
        return resultType;
    }

    public byte[] getQueryAsBytes() {
        return queryAsBytes;
    }
}
