package org.nakedobjects.nos.store.hibernate.type;

import java.sql.Blob;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;

import org.hibernate.Hibernate;
import org.hibernate.HibernateException;
import org.nakedobjects.nof.core.adapter.value.AbstractImageAdapter;


public abstract class AbstractImageType extends ImmutableUserType {
    protected abstract AbstractImageAdapter getImageAdapter(Object value);

    public Object nullSafeGet(ResultSet rs, String[] names, Object owner) throws HibernateException, SQLException {
        final Blob blob = rs.getBlob(names[0]);
        if (rs.wasNull()) {
            return null;
        }
        final AbstractImageAdapter imageAdapter = getImageAdapter(null);
        imageAdapter.restoreFromByteArray(blob.getBytes(1, (int) blob.length()));
        return imageAdapter.getObject();
    }

    public void nullSafeSet(PreparedStatement st, Object value, int index) throws HibernateException, SQLException {
        if (value == null) {
            st.setNull(index, Types.BLOB);
        } else {
            st.setBlob(index, Hibernate.createBlob(getImageAdapter(value).getAsByteArray()));
        }
    }

    public abstract Class returnedClass();

    public int[] sqlTypes() {
        return new int[] { Types.BLOB };
    }
}
