package org.nakedobjects.nos.store.hibernate.type;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.hibernate.Hibernate;
import org.hibernate.HibernateException;
import org.nakedobjects.applib.value.DateTime;
/**
 * A user type that maps an SQL DATE to a NOF DateTime value.
 */
public class DateTimeType extends ImmutableUserType {

	public Object nullSafeGet(final ResultSet rs, final String[] names, final Object owner)
			throws HibernateException, SQLException {
		java.util.Date date = rs.getDate(names[0]);
        if (rs.wasNull()) return null;
		return new DateTime(date);
	}

	public void nullSafeSet(final PreparedStatement st, final Object value, final int index)
		throws HibernateException, SQLException {
		if (value == null) {
			st.setNull(index, Hibernate.DATE.sqlType());
		} else {
			DateTime dateTime = (DateTime)value;
			java.sql.Date sqlDate = new java.sql.Date( dateTime.dateValue().getTime() );
			st.setDate(index, sqlDate);
		}
	}

	public Class returnedClass() {
		return DateTime.class;
	}

	public int[] sqlTypes() {
		return new int[]{ Hibernate.DATE.sqlType() };
	}
}
// Copyright (c) Naked Objects Group Ltd.
