package org.nakedobjects.nos.store.hibernate.type;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.hibernate.Hibernate;
import org.hibernate.HibernateException;
import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.Oid;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nof.core.service.ServiceUtil;
import org.nakedobjects.nos.store.hibernate.HibernateOid;
/**
 * A user type that maps an SQL string to a NOF DomainModelResource.
 * 
 * TODO remove this class as it no longer has a counterpart in the NOF (was DomainModelResource)
 */
public class DomainModelResourceType extends ImmutableUserType {

	public Object nullSafeGet(final ResultSet rs, final String[] names, final Object owner)
			throws HibernateException, SQLException {
		String id = rs.getString(names[0]);
        if (rs.wasNull()) return null;
        Oid oid = new HibernateOid(id,id,id);
        NakedObject adapter = NakedObjectsContext.getObjectLoader().getAdapterFor(oid);
        if (adapter == null) {
        	throw new HibernateException("Unknown DomainModelResource: id="+id);
        }
		return adapter.getObject();
	}

	public void nullSafeSet(final PreparedStatement st, final Object value, final int index)
		throws HibernateException, SQLException {
		if (value == null) {
			st.setNull(index, Hibernate.STRING.sqlType());
		} else {
			st.setString(index, ServiceUtil.id(value));
		}
	}

	public Class returnedClass() {
		return Object.class;
	}

	public int[] sqlTypes() {
		return new int[]{ Hibernate.STRING.sqlType() };
	}
}
// Copyright (c) Naked Objects Group Ltd.
